package cn.iocoder.yudao.module.system.service.commonlyused;

import cn.iocoder.yudao.framework.common.pojo.PageResult;
import cn.iocoder.yudao.module.system.controller.admin.commonlyused.vo.CommonlyUsedPageReqVO;
import cn.iocoder.yudao.module.system.controller.admin.commonlyused.vo.CommonlyUsedSaveReqVO;
import cn.iocoder.yudao.module.system.controller.admin.commonlyused.vo.CommonlyUsedVO;
import cn.iocoder.yudao.module.system.dal.dataobject.commonlyused.CommonlyUsedDO;

import javax.validation.Valid;
import java.util.List;

/**
 * 用户常用应用配置 Service 接口
 *
 * @author 艾楷
 */
public interface CommonlyUsedService {

    /**
     * 创建用户常用应用配置
     *
     * @param createReqVO 创建信息
     * @return 编号
     */
    Long createCommonlyUsed(@Valid CommonlyUsedSaveReqVO createReqVO);

    /**
     * 更新用户常用应用配置
     *
     * @param updateReqVO 更新信息
     */
    void updateCommonlyUsed(@Valid CommonlyUsedSaveReqVO updateReqVO);

    /**
     * 删除用户常用应用配置
     *
     * @param id 编号
     */
    void deleteCommonlyUsed(Long id);

    /**
     * 获得用户常用应用配置
     *
     * @param id 编号
     * @return 用户常用应用配置
     */
    CommonlyUsedDO getCommonlyUsed(Long id);

    /**
     * 获得用户常用应用配置分页
     *
     * @param pageReqVO 分页查询
     * @return 用户常用应用配置分页
     */
    PageResult<CommonlyUsedDO> getCommonlyUsedPage(CommonlyUsedPageReqVO pageReqVO);

    /**
     * 获得用户常用应用配置列表
     *
     * @return
     */
    CommonlyUsedVO getCommonlyUsedList();

    /**
     * 批量更新
     *
     * @param list
     */
    void batchUpdate(List<CommonlyUsedSaveReqVO> list);

    /**
     * 批量删除
     *
     * @param ids
     */
    void batchDelete(List<Long> ids);

    /**
     * 批量创建编辑删除
     *
     * @param list
     */
    void batchCreateOrEditOrDel(List<CommonlyUsedSaveReqVO> list);
}
